unit U_TradeFinishClothOutEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, cxSpinEdit,
  StdCtrls, ExtCtrls, cxLookAndFeels, cxLookAndFeelPainters, 
   cxNavigator, dxDateRanges, dxBarBuiltInMenu,
  U_BaseInput, System.ImageList, Vcl.ImgList, cxPC, 
  dxScrollbarAnnotations;

type
  TfrmTradeFinishClothOutEdit = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DS_1: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    GPM_1: TcxGridPopupMenu;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1CRType: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    v1Column5: TcxGridDBColumn;
    v1CheJian: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column11: TcxGridDBColumn;
    Tv1Column12: TcxGridDBColumn;
    Tv1Column13: TcxGridDBColumn;
    Tv1Column14: TcxGridDBColumn;
    DS_2: TDataSource;
    CDS_2: TClientDataSet;
    GPM_2: TcxGridPopupMenu;
    ADO_2: TADOQuery;
    cxPageControl1: TcxPageControl;
    cxTabSheet2: TcxTabSheet;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    cxGridDBColumn19: TcxGridDBColumn;
    v1OrderNo: TcxGridDBColumn;
    v1ConNo: TcxGridDBColumn;
    v1DeliveryDate: TcxGridDBColumn;
    cxGridDBColumn20: TcxGridDBColumn;
    cxGridDBColumn21: TcxGridDBColumn;
    cxGridDBColumn22: TcxGridDBColumn;
    v1OrdDefStr1: TcxGridDBColumn;
    v1MPRTCodeName: TcxGridDBColumn;
    v1MPRTSpec: TcxGridDBColumn;
    cxGridDBColumn23: TcxGridDBColumn;
    v1MPRTMF: TcxGridDBColumn;
    v1MPRTKZ: TcxGridDBColumn;
    v1PRTColor: TcxGridDBColumn;
    cxGridDBColumn24: TcxGridDBColumn;
    cxGridDBColumn25: TcxGridDBColumn;
    cxGridDBColumn26: TcxGridDBColumn;
    cxGridDBColumn27: TcxGridDBColumn;
    cxGridDBColumn28: TcxGridDBColumn;
    cxGridDBColumn29: TcxGridDBColumn;
    cxGridDBColumn30: TcxGridDBColumn;
    cxGridDBColumn31: TcxGridDBColumn;
    cxGridDBColumn32: TcxGridDBColumn;
    cxGridLevel2: TcxGridLevel;
    Pnl_F2: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column13PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure TV2DblClick(Sender: TObject);
  private
    { Private declarations }
    function SaveData(): Boolean;
    procedure InitReceipt();
  public
    { Public declarations }
    FBCId, FStkName, FKHName: string;
  end;

var
  frmTradeFinishClothOutEdit: TfrmTradeFinishClothOutEdit;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_TradeFinishClothStkSel, U_CompanySel,
  U_TradePlanSel;

{$R *.dfm}
procedure TfrmTradeFinishClothOutEdit.InitReceipt();
var
  FWSql: string;
begin

  case cxPageControl1.ActivePageIndex of
    0:
      begin
        FWSql := SGetHintFilters(Pnl_F2, 1, 2);
        if FWSql <> '' then
          FWSql := ' and ' + FWSql;

        with ADO_2 do
        begin
          Close;
          sql.Clear;
          sql.Add('select A.*    ');
          sql.Add(',SumPiece=(select Sum(X.Piece) from BS_Cloth_IO X where X.IOType=''加工出库'' and X.fromSubID=A.SubID and isnull(X.STKNAME,'''')=' + Quotedstr(Trim(FSTKNAME)) + ')');
          sql.Add(',SumQty=(select Sum(X.Qty) from BS_Cloth_IO X where X.IOType=''加工出库'' and X.fromSubID=A.SubID and isnull(X.STKNAME,'''')=' + Quotedstr(Trim(FSTKNAME)) + ')');
          sql.Add('from V_Trade_Plan_Fty A ');
          sql.add('where Status=''9'' ');
          if Trim(FWSql) <> '' then
            sql.Add(FWSql);
          Open;
        end;

        SCreateCDS(ADO_2, CDS_2);
        SInitCDSData(ADO_2, CDS_2);
      end;
  end;

end;

procedure TfrmTradeFinishClothOutEdit.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    InitReceipt();
  end;
end;

procedure TfrmTradeFinishClothOutEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmTradeFinishClothOutEdit.TBAddClick(Sender: TObject);
begin
  try
    frmTradeFinishClothStkSel := TfrmTradeFinishClothStkSel.Create(Application);
    with frmTradeFinishClothStkSel do
    begin
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        frmTradeFinishClothStkSel.CDS_Main.DisableControls;
        with frmTradeFinishClothStkSel.CDS_Main do
        begin
          First;
          while frmTradeFinishClothStkSel.CDS_Main.Locate('SSel', True, []) do
          begin
            with Self.CDS_Sub do
            begin
              Append;
              FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
              FieldByName('STKID').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('BCIOID').Value;
              FieldByName('IOType').Value := '检验出库';

              FieldByName('ToConNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromConNo').Value;
              FieldByName('FromConNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromConNo').Value;

              FieldByName('FromCoNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromCoNo').Value;
              FieldByName('FromCoName').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromCoName').Value;
              FieldByName('StkCoNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('StkCoName').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;
              FieldByName('ToCoNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('ToCoName').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;

              FieldByName('C_Code').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Code').Value;
              FieldByName('C_Name').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Name').Value;
              FieldByName('C_EName').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_EName').Value;
              FieldByName('C_Spec').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Spec').Value;
              FieldByName('QtyUnit').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('QtyUnit').Value;
              FieldByName('Qty').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('STKQTY').Value;
              FieldByName('Piece').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('StkPiece').Value;
              FieldByName('BatchNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('BatchNo').Value;
              FieldByName('C_Width').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Width').Value;
              FieldByName('C_GramWeight').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_GramWeight').Value;
              FieldByName('FromOrdNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromOrdNo').Value;
              FieldByName('FromMainId').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromMainId').Value;
              FieldByName('FromSubId').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromSubId').Value;

              FieldByName('ToOrdNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromOrdNo').Value;
              FieldByName('ToMainId').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromMainId').Value;
              FieldByName('ToSubId').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FromSubId').Value;

              FieldByName('Workshop').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('Workshop').Value;
              FieldByName('PieceWeight').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('PieceWeight').Value;
              FieldByName('C_ColorDepth').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_ColorDepth').Value;
              FieldByName('C_Color').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Color').Value;

              FieldByName('C_EColor').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_EColor').Value;

              FieldByName('C_ColorNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_ColorNo').Value;
              FieldByName('FtyPCId').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('FtyPCId').Value;

              FieldByName('C_Pattern').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Pattern').Value;
              FieldByName('C_Composition').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_Composition').Value;
              FieldByName('C_StyleNo').Value := frmTradeFinishClothStkSel.CDS_Main.fieldbyname('C_StyleNo').Value;

            end;
            frmTradeFinishClothStkSel.CDS_Main.Delete;
          end;
        end;
        frmTradeFinishClothStkSel.CDS_Main.EnableControls;
      end;
    end;
  finally
    frmTradeFinishClothStkSel.Free;
  end;

end;

function TfrmTradeFinishClothOutEdit.SaveData(): Boolean;
var
  MBCIOID, Maxno: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
          Open;
        end;
        MBCIOID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
        if Trim(MBCIOID) = '' then
        begin
          if not GetLSNo(ADOQueryCmd, Maxno, 'MC', 'BS_Cloth_IO', 4, 1) then
            raise Exception.Create('取染色坯布出库编号失败！');
        end
        else
        begin
          Maxno := Trim(MBCIOID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MBCIOID) = '' then
          begin
            Append;
            FieldByName('Fillid').Value := Trim(Dcode);
            FieldByName('Filler').Value := Trim(DName);
          end
          else
          begin
            Edit;
            FieldByName('Editid').Value := Trim(Dcode);
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'BS_Cloth_IO', 0);
          FieldByName('STKName').Value := FSTKName;
          FieldByName('BCIOID').Value := Trim(Maxno);
          FieldByName('IOFlag').Value := '出库';
          FieldByName('IOQtyFlag').Value := -1;
          FieldByName('STKID').Value := CDS_Sub.fieldbyname('STKID').Value;
          FieldByName('FromCoNo').Value := CDS_Sub.fieldbyname('FromCoNo').Value;
          FieldByName('FromCoName').Value := CDS_Sub.fieldbyname('FromCoName').Value;
          FieldByName('StkCoNo').Value := CDS_Sub.fieldbyname('StkCoNo').Value;
          FieldByName('ToCoNo').Value := CDS_Sub.fieldbyname('ToCoNo').Value;
          FieldByName('FromOrdNo').Value := CDS_Sub.fieldbyname('FromOrdNo').Value;
          FieldByName('FromMainId').Value := CDS_Sub.fieldbyname('FromMainId').Value;
          FieldByName('FromSubId').Value := CDS_Sub.fieldbyname('FromSubId').Value;

          FieldByName('ToOrdNo').Value := CDS_Sub.fieldbyname('ToOrdNo').Value;
          FieldByName('ToMainId').Value := CDS_Sub.fieldbyname('ToMainId').Value;
          FieldByName('ToSubId').Value := CDS_Sub.fieldbyname('ToSubId').Value;

          FieldByName('FromConNo').Value := CDS_Sub.fieldbyname('FromConNo').Value;

          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update BS_Cloth_IO Set StkPiece=(select Sum(isnull(Piece,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID)');
          sql.Add(',STKQty=(select Sum(isnull(Qty,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID )');
          sql.Add('where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('STKQty').Value < 0 then
          raise Exception.Create('出库数量大于入库数量不能保存！');

        if ADOQueryTemp.FieldByName('StkPiece').Value < 0 then
          raise Exception.Create('出库匹数大于入库匹数不能保存！');
        with ADOQueryCmd do
        begin
          Close;
          Sql.Clear;
          Sql.Add('exec P_BS_Cloth_Move ');
          Sql.Add(' @BCIOID=' + quotedstr(Trim(Maxno)));
          Open;
        end;
        if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
          raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)       ');
          sql.Add('values(''贸易待检布出库''    ');
          sql.Add(',' + quotedstr(Maxno));
          sql.Add(',''保存''   ');
          sql.Add(',' + quotedstr(DName));
          sql.Add(',' + quotedstr(trim(self.Caption)));
          sql.Add(',' + quotedstr(Maxno));
          sql.Add(')  ');
          ExecSQL;
        end;
        Edit;
        FieldByName('BCIOID').Value := Trim(Maxno);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmTradeFinishClothOutEdit.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmTradeFinishClothOutEdit.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(FSTKName + '出库登记', Tv1, '贸易汇总仓库');
  InitReceipt();
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from BS_Cloth_IO A');
    sql.Add(' where BCIOID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
//  fsj:='select name=CJName ,Code=null from CheJian';
//  SInitCxGridComboBoxBySql(ADOQueryTemp,v1CheJian,fsj,0,True,'');
end;

procedure TfrmTradeFinishClothOutEdit.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('exec P_Fin_Flow_Judge ');
      Sql.Add(' @FFIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
    begin
      Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
      exit;
    end;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        Sql.Clear;
        sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)       ');
        sql.Add('values(''贸易待检布入库''    ');
        sql.Add(',' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
        sql.Add(',''删除''   ');
        sql.Add(',' + quotedstr(DName));
        sql.Add(',' + quotedstr(trim(self.Caption)));
        sql.Add(',' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
        sql.Add(')  ');

        Sql.Add('exec P_BS_Cloth_Out_Del ');
        Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
        Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
        Sql.Add(',@DName=' + quotedstr(Trim(DName)));
        Open;
      end;
      if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
        raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    end;
  end
  else
    CDS_Sub.Delete;
end;

procedure TfrmTradeFinishClothOutEdit.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('IOTime', null, []) = True then
  begin
    Application.MessageBox('出库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('IOType', null, []) = True then
  begin
    Application.MessageBox('出库类型不能为空!', '提示', 0);
    Exit;
  end;
 { if CDS_Sub.Locate('CRType;LCKNO', VarArrayOf(['加工出库', Null]), [loPartialKey]) then
  begin
    Application.MessageBox('加工出库的数据流程卡号不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('Piece', null, []) = True then
  begin
    Application.MessageBox('匹数不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if SaveData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmTradeFinishClothOutEdit.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(fSTKName + '出库登记', Tv1, '贸易汇总仓库');

end;

procedure TfrmTradeFinishClothOutEdit.Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      if Trim(Self.CDS_Sub.fieldbyname('IOType').AsString) = '销售出库' then
        FCoType := '客户'
      else
        FCoType := '供应商';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ToCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('ToCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmTradeFinishClothOutEdit.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FFSPID: string;
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
      Open;
    end;
    FFSPID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
    if Trim(FFSPID) <> '' then
    begin
      v1CRType.Options.Editing := False;
    end
    else
    begin
      v1CRType.Options.Editing := True;
    end;
  end
  else
  begin
    v1CRType.Options.Editing := True;
  end;
end;

procedure TfrmTradeFinishClothOutEdit.TV2DblClick(Sender: TObject);
begin
  if not Self.CDS_Sub.IsEmpty then
  begin
    with Self.CDS_Sub do
    begin
      Edit;
      FieldByName('ToOrdNo').Value := Trim(CDS_2.fieldbyname('OrderNo').AsString);
      FieldByName('ToMainId').Value := Trim(CDS_2.fieldbyname('MainId').AsString);
      FieldByName('ToSubId').Value := Trim(CDS_2.fieldbyname('SubId').AsString);
    end;
  end;
end;

procedure TfrmTradeFinishClothOutEdit.v1Column13PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmTradePlanSel := TfrmTradePlanSel.Create(Application);
    with frmTradePlanSel do
    begin
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ToOrdNo').Value := Trim(frmTradePlanSel.CDS_1.fieldbyname('OrderNo').AsString);
          FieldByName('ToMainId').Value := Trim(frmTradePlanSel.CDS_1.fieldbyname('MainId').AsString);
          FieldByName('ToSubId').Value := Trim(frmTradePlanSel.CDS_1.fieldbyname('SubId').AsString);
        end;
      end;
    end;
  finally
    frmTradePlanSel.Free;
  end;
end;

end.

